// int^X^bN

public class IntStack {
	private int max;			// X^bN̗e
	private int ptr;			// X^bN|C^
	private int[] stk;		// X^bN̖{

	//--- sOFX^bN ---//
	public class EmptyIntStackException extends RuntimeException {
		public EmptyIntStackException() { }
	}

	//--- sOFX^bNt ---//
	public class OverflowIntStackException extends RuntimeException {
		public OverflowIntStackException() { }
	}

	//--- RXgN^ ---//
	public IntStack(int capacity) {
		ptr = 0;
		max = capacity;
		try {
			stk = new int[max];				// X^bN{̗p̔z𐶐
		} catch (OutOfMemoryError e) {	// łȂ
			max = 0;
		}
	}

	//--- X^bNxvbV ---//
	public int push(int x) throws OverflowIntStackException {
		if (ptr >= max)									// X^bN͖t
			throw new OverflowIntStackException();
		return stk[ptr++] = x;
	}

	//--- X^bNf[^|bvĩf[^oj ---//
	public int pop() throws EmptyIntStackException {
		if (ptr <= 0)										// X^bN͋
			throw new EmptyIntStackException();
		return stk[--ptr];
	}

	//--- X^bNf[^s[Nĩf[^`j ---//
	public int peek() throws EmptyIntStackException {
		if (ptr <= 0)										// X^bN͋
			throw new EmptyIntStackException();
		return stk[ptr - 1];
	}

	//--- X^bNxTăCfbNXiȂ-1jԂ ---//
	public int indexOf(int x) {
		for (int i = ptr - 1; i >= 0; i--)		// 㑤`T
			if (stk[i] == x)
				return i;		// T
		return -1;				// Ts
	}

	//--- X^bNɂ ---//
	public void clear() {
		ptr = 0;
	}

	//--- X^bN̗eʂԂ ---//
	public int capacity() {
		return max;
	}

	//--- X^bNɐς܂Ăf[^Ԃ ---//
	public int size() {
		return ptr;
	}

	//--- X^bN͋ł邩 ---//
	public boolean isEmpty() {
		return ptr <= 0;
	}

	//--- X^bN͖tł邩 ---//
	public boolean isFull() {
		return ptr >= max;
	}

	//--- X^bN̑Sf[^ꁨ̏ɕ\ ---//
	public void dump() {
		if (ptr <= 0)
			System.out.println("X^bN͋łB");
		else {
			for (int i = 0; i < ptr; i++)
				System.out.print(stk[i] + " ");
			System.out.println();
		}
	}
}
