// q[v\[g

import java.util.Scanner;

class HeapSort {

	//--- z̗vfa[idx1]a[idx2]̒l ---//
	static void swap(int[] a, int idx1, int idx2) {
		int t = a[idx1];  a[idx1] = a[idx2];  a[idx2] = t;
	}

	//--- a[left]`a[right]q[v ---//
	static void downHeap(int[] a, int left, int right) {
		int temp = a[left];		// 
		int child;					// 傫ق̎q
		int parent;					// e

		for (parent = left; parent < (right + 1) / 2; parent = child) {
			int cl = parent * 2 + 1;		// ̎q
			int cr = cl + 1;					// E̎q
			child = (cr <= right && a[cr] > a[cl]) ? cr : cl;	// 傫ق
			if (temp >= a[child])
				break;
			a[parent] = a[child];
		}
		a[parent] = temp;
	}

	//--- q[v\[g ---//
	static void heapSort(int[] a, int n) {
		for (int i = (n - 1) / 2; i >= 0; i--)	// a[i]`a[n-1]q[v
			downHeap(a, i, n - 1);

		for (int i = n - 1; i > 0; i--) {
			swap(a, 0, i);				// ővfƖ\[gvf
			downHeap(a, 0, i - 1);	// a[0]`a[i-1]q[v
		}
	}

	public static void main(String[] args) {
		Scanner stdIn = new Scanner(System.in);

		System.out.println("q[v\[g");
		System.out.print("vfF");
		int nx = stdIn.nextInt();
		int[] x = new int[nx];

		for (int i = 0; i < nx; i++) {
			System.out.print("x[" + i + "]F");
			x[i] = stdIn.nextInt();
		}

		heapSort(x, nx);	// zxq[v\[g

		System.out.println("Ƀ\[g܂B");
		for (int i = 0; i < nx; i++)
			System.out.println("x[" + i + "]" + x[i]);
	}
}
