// int^̏W

public class IntSet {
	private int max;			// W̗e
	private int num;			// W̗vf
	private int[] set;		// W{

	//--- RXgN^ ---//
	public IntSet(int capacity) {
		num = 0;
		max = capacity;
		try {
			set = new int[max];				// W{̗p̔z𐶐
		}
		catch (OutOfMemoryError e) {		// z̐Ɏs
			max = 0;
		}
	}

	//--- W̗e ---//
	public int capacity() {
		return max;
	}

	//--- W̗vf ---//
	public int size() {
		return num;
	}

	//--- WnTăCfbNXiȂ-1jԂ ---//
	public int indexOf(int n) {
		for (int i = 0; i < num; i++)
			if (set[i] == n)
				return i;					// ܂܂
		return -1;							// ܂܂Ȃ
	}

	//--- WnĂ邩 ---//
	public boolean contains(int n) {
		return (indexOf(n) != -1) ? true : false;
	}

	//--- Wnǉ ---//
	public boolean add(int n) {
		if (num >= max || contains(n) == true)	// t or n܂܂Ă
			return false;
		else {
			set[num++] = n;							// ɒǉ
			return true;
		}
	}

	//--- Wn폜 ---//
	public boolean remove(int n) {
		int idx;					// ni[Ăvf̃CfbNX

		if (num <= 0 || (idx = indexOf(n)) == -1)	//  or n܂܂ĂȂ
			return false;
		else {
			set[idx] = set[--num];					// ̗vf폜ʒuɈړ
			return true;
		}
	}

	//--- WsɃRs[ ---//
	public void copyTo(IntSet s)	{
		int n = (s.max < num) ? s.max : num;	// Rs[vf
		for (int i = 0; i < n; i++)
			s.set[i] = set[i];
		s.num = n;
	}

	//--- WsRs[ ---//
	public void copyFrom(IntSet s)	{
		int n = (max < s.num) ? max : s.num;	// Rs[vf
		for (int i = 0; i < n; i++)
			set[i] = s.set[i];
		num = n;
	}

	//--- WsƓ ---//
	public boolean equalTo(IntSet s)	{
		if (num != s.num)							// vfȂ
			return false;							// WȂ

		for (int i = 0; i < num; i++) {
			int j = 0;
			for ( ; j < s.num; j++)
				if (set[i] == s.set[j])
					break;
			if (j == s.num)						// set[i]sɊ܂܂Ȃ
				return false;
		}
		return true;
	}

	//--- Ws1s2̘aWRs[ ---//
	public void unionOf(IntSet s1, IntSet s2) {
		copyFrom(s1);								// Ws1Rs[
		for (int i = 0; i < s2.num; i++)		// Ws2̗vfǉ
			add(s2.set[i]);
	}

	//--- "{ a b c }"`̕\ɕϊ ---//
	public String toString() {
		StringBuffer temp = new StringBuffer("{ ");
		for (int i = 0; i < num; i++)
			temp.append(set[i] + " ");
		temp.append("}");
		return temp.toString();
	}
}
